/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package doubleSlit;

import java.awt.Canvas;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Point;
import java.util.ArrayDeque;

/**
 *
 * @author Mikulas_s_capicu
 */
public class DoubleSlitCanvas extends Canvas {

    double pauza = 10.0;
    boolean uvodnaAnimacia = true;
    int dlzkaStrany = -1;
    private Image offscreen = null;
    private Graphics bufferGraphics = null;

    //int elektronX = -1;
    //int elektronY = -1;
    private ArrayDeque<Point> pozicieElektronov = new ArrayDeque<Point>(10);
    private boolean pripravenyBuffer = false;
    boolean vykreslenaPlatna = false;

    @Override
    public void paint(Graphics g) {

        if( ! pripravenyBuffer){
            offscreen = createImage(getSize().width, getSize().height);
            bufferGraphics = offscreen.getGraphics();
            pripravenyBuffer = true;
        }

         
        if (uvodnaAnimacia){
            vycistiPlochu();
            vycistiZasobnikElektronov();
            bufferGraphics.drawRect(0, 0, dlzkaStrany, getSize().height - 27);
        }else{
            if (! vykreslenaPlatna){
                bufferGraphics.drawRect(0, 0, getSize().width - 1, getSize().height - 27);
                bufferGraphics.drawString("F", getSize().width - 20, getSize().height - 5);
                vykreslenaPlatna = true;
            }
            vykresliElektronyVZasobniku(bufferGraphics);
        }
        
        g.drawImage(offscreen, 0, 0, this);
    }

    @Override
    public void update(Graphics g) {
    	paint(g);
    }

    private void vycistiPlochu(){
        Dimension size = getSize();
        bufferGraphics.clearRect(0, 0, size.width, size.height);
    }

    private void vycistiZasobnikElektronov(){
        pozicieElektronov.clear();
    }
    
    private synchronized void vykresliElektronyVZasobniku(Graphics g){
        while(!pozicieElektronov.isEmpty()){
            Point p = pozicieElektronov.removeFirst();
            g.drawLine(p.x, p.y, p.x, p.y);
        }
    }

    synchronized void pridajPoziciuElektronu(int x, int y){
        pozicieElektronov.addFirst(new Point(x,y));
    }
}