/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package fotoefekt;

import java.awt.Image;
import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Random;
import javax.imageio.ImageIO;

/**
 *
 * @author Mikulas_s_capicu
 */
class RiadiaciThread extends Thread {

    private FotoefektPanel panel;
    private FotoefektCanvas canvas;
    boolean koniec = false;
    private int vyskaObr = 14;  //vyska obrazku luca

    private final double[] vystupnePrace = {2.29*1.602*Math.pow(10, -19),
                              4.15*1.602*Math.pow(10, -19),
                              2.36*1.602*Math.pow(10, -19),
                              3.75*1.602*Math.pow(10, -19)};
    //hodnoty vystupnej prace pre kovy z ktorych moze byt katoda: draslik, hlinik, sodik, uran
    private final double planckovaKonstanta = 1.054 * Math.pow(10, -34);
    private final double c = 300000000; //rychlost svetla
    private final double hmotnostElektronu = 9.11 * Math.pow(10, -31); //v kg
    

    RiadiaciThread(FotoefektPanel ref){
        panel = ref;
        canvas = panel.fotoefektCanvas1;
    }

    @Override
    public void run() {
        double vlnovaDlzka = panel.vlnovaDlzkaSlider.getValue();
        int intenzita = panel.intenzitaSlider.getValue();
        int kov = canvas.aktualnyKov;
        if (! panel.vyucujeSaStudent){
            panel.vlnovaDlzkaSlider.setEnabled(false);
            panel.intenzitaSlider.setEnabled(false);
            panel.vyberKovu.setEnabled(false);
        }
        
        panel.button.setText("Zastav simuláciu");

        Random random = new Random();
        ArrayList<Integer> elektronyNaVykreslenie = new ArrayList<Integer>();
        while (elektronyNaVykreslenie.size() != intenzita){
            int x = random.nextInt(10);
            if ( !(elektronyNaVykreslenie.contains(new Integer(x))) ){
              elektronyNaVykreslenie.add(new Integer(x));
            }
        }

        Image obr = nastavObrazok(vlnovaDlzka);

        for(int i=0; i<intenzita;i++){
            canvas.luce[i].obrazok = obr;
            vyratajZmenu(canvas.luce[i], elektronyNaVykreslenie.get(i));

        }

        vlnovaDlzka *= Math.pow(10, -9);
        double energiaFotonu =   2*Math.PI*
                                 planckovaKonstanta*
                                 c / vlnovaDlzka ;

        canvas.pocetLucov = intenzita;

        canvas.animujLuce = true;
        
        while(nieSuVsetkyLuceVCieli(intenzita, elektronyNaVykreslenie)){
            canvas.repaint(152, 32, 406, 268);
            try {
                sleep(10);
            } catch (InterruptedException ex) {
                System.out.println(ex.getMessage());
            }
            for(int i=0; i<intenzita;i++){
              int cEl = elektronyNaVykreslenie.get(i);
              if (canvas.luce[i].x == canvas.elektrony[cEl].x){
                continue;
              }

              if (canvas.luce[i].x -
                  canvas.elektrony[cEl].x < 3){
                  canvas.luce[i].x = canvas.elektrony[cEl].x ;
                  canvas.luce[i].y = canvas.elektrony[cEl].y - vyskaObr;
                  
              }else{
                canvas.luce[i].x += canvas.luce[i].zmenaX;
                canvas.luce[i].y += canvas.luce[i].zmenaY;
              }
              
            }
        }
       

        canvas.animujLuce = false;
        double kinetickaEnergia = energiaFotonu - vystupnePrace[kov];
        

        if (kinetickaEnergia > 0){
            double rychlostElektronu = Math.sqrt(2* kinetickaEnergia / hmotnostElektronu);
            double dx = rychlostElektronu / 500000;
            
            while(nieSuVsetkyElektronyVCieli(elektronyNaVykreslenie) && !koniec){
              canvas.repaint(152, 32, 406, 268);
              try {
                sleep(12);
              } catch (InterruptedException ex) {
                System.out.println(ex.getMessage());
              }
              for(int i=0; i<elektronyNaVykreslenie.size();i++){
                int pos =  elektronyNaVykreslenie.get(i);

                if (canvas.poziciaAnody == canvas.elektrony[pos].x){
                  continue;
                }

                if (canvas.poziciaAnody - canvas.elektrony[pos].x < 3){
                    canvas.elektrony[pos].x = canvas.poziciaAnody;
                }else{
                    canvas.elektrony[pos].x += dx;
                }
              }
            }

            for(int i=0; i<elektronyNaVykreslenie.size();i++){
                int pos =  elektronyNaVykreslenie.get(i);
                canvas.elektrony[pos].x = 189;
                canvas.elektrony[pos].y = 154+14*pos;
            }

            canvas.repaint(152, 32, 406, 268);

            while((canvas.indexKoncaRucicky < intenzita) && !koniec){
                canvas.indexKoncaRucicky++;
                canvas.repaint(641, 230, 65, 54);
                try {
                    sleep(6);
                } catch (InterruptedException ex) {
                    System.out.println(ex.getMessage());
                }
            }
            
            try {
                    if (!koniec){
                        sleep(500);
                    }
                } catch (InterruptedException ex) {
                    System.out.println(ex.getMessage());
                }

            while((canvas.indexKoncaRucicky > 0) && !koniec){
                canvas.indexKoncaRucicky--;
                canvas.repaint();
                try {
                    sleep(6);
                } catch (InterruptedException ex) {
                    System.out.println(ex.getMessage());
                }
            }
        }

        for(int i=0; i<intenzita; i++){
           canvas.luce[i].x = canvas.lampaX;
           canvas.luce[i].y = canvas.lampaY;
        }

        canvas.repaint();

        canvas.indexKoncaRucicky = 0;
        if (! panel.vyucujeSaStudent){
            panel.vlnovaDlzkaSlider.setEnabled(true);
            panel.intenzitaSlider.setEnabled(true);
            panel.vyberKovu.setEnabled(true);
        }
        panel.button.setText("Zasvieť svetlo");
        //canvas.repaint();

    }

    private Image nastavObrazok(double vlnovaDlzka) {
       String farba = "";
       if (vlnovaDlzka < 380){
         farba = "neviditelna.png";
       }else if(vlnovaDlzka < 420){
         farba = "fialova.png";
       }else if(vlnovaDlzka < 450){
         farba = "modrofialova.png";
       }else if(vlnovaDlzka < 480){
         farba = "modra.png";
       }else if(vlnovaDlzka < 510){
         farba = "modrozelena.png";
       }else if(vlnovaDlzka < 550){
         farba = "zelena.png";
       }else if(vlnovaDlzka < 570){
         farba = "zltozelena.png";
       }else if(vlnovaDlzka < 590){
         farba = "zlta.png";
       }else if(vlnovaDlzka < 630){
         farba = "oranzova.png";
       }else{
         farba = "cervena.png";
       }
       try {
                URL cesta = getClass().getResource(farba);
                return ImageIO.read(cesta);
            } catch (IOException ex) {
                System.out.println(ex.getMessage());
                return null;
            }
    }

    private void vyratajZmenu(SvetelnyLuc svetelnyLuc, int elektron) {
        double ZmenaXX = canvas.elektrony[elektron].x;
        double ZmenaYY = canvas.elektrony[elektron].y - vyskaObr;
        ZmenaXX -= canvas.lampaX;
        ZmenaYY -= canvas.lampaY;
        double velkostVektora = Math.sqrt(Math.pow(ZmenaXX, 2) + Math.pow(ZmenaYY, 2));
        double delitel =  velkostVektora / 30;
        ZmenaXX /= delitel;
        ZmenaYY /= delitel;
        svetelnyLuc.zmenaX = ZmenaXX;
        svetelnyLuc.zmenaY = ZmenaYY;
    }

    private boolean nieSuVsetkyLuceVCieli(int pocetLucov, ArrayList<Integer> elektrony) {
        for(int i=0; i<pocetLucov;i++){
            int pos =  elektrony.get(i);
            if (canvas.luce[i].x != canvas.elektrony[pos].x){
              return true;
            }
        }
        return false;
    }

    private boolean nieSuVsetkyElektronyVCieli(ArrayList<Integer> elektrony) {
        for(int i=0; i<elektrony.size();i++){
            int pos =  elektrony.get(i);
            if (canvas.elektrony[pos].x != canvas.poziciaAnody){
              return true;
            }
        }
        return false;
    }

}